/* 
    Common interrupt module.
*/

#include "simplelink.h"

/*
    WiFi interrupt related functions and variables.
*/

P_EVENT_HANDLER wifi_isr_event;

void bsp_wifi_driver_interrupt_enable ( void )
{
    NVIC_IntEnable( IVT_INT_EXTI9_5 );
}

void bsp_wifi_driver_interrupt_disable ( void )
{
    NVIC_IntDisable( IVT_INT_EXTI9_5 );
}

//  WiFi ISR Function.

void WIFI_EXT_ISR ( void ) iv IVT_INT_EXTI9_5 ics ICS_AUTO
{
    EXTI_PR.B9 = 1;

    if ( wifi_isr_event != ( void * ) 0 )
    {
        ( *wifi_isr_event )( 0 );
    }
}

/*
    USB interrupt related functions and variables.
*/

//void USB_ISR( ) iv IVT_INT_OTG_FS
//{
//    USBHost_IntHandler( );
//}

/*
    Common initialize functions which should initialize all necessary 
    interrupts.
*/

void interrupts_enable ( void )
{
    /*
        Initialize external interrupt on CC3100 INT pin.

        NOTE : 

            Interrupt must be configured to trigger on rising edge.
    */

    SYSCFGEN_bit = 1;
    SYSCFG_EXTICR3 |= 0x00000020;
    EXTI_RTSR |= ( 1ul << TR9 );
    EXTI_IMR |= ( 1ul << MR9 );
    
    /*
        Initialize global interrupts and enable vectors.
    */
    
//    NVIC_IntEnable( IVT_INT_OTG_FS );
    NVIC_IntEnable( IVT_INT_EXTI9_5 );
    EnableInterrupts( );
}