#include "HIDDevice_Keyboard_objects.h"
#include "HIDDevice_Keyboard_resources.h"
#include "built_in.h"


// TFT module connections
unsigned int TFT_DataPort at GPIOG_ODR;
sbit TFT_RST at GPIOF_ODR.B11;
sbit TFT_RS at GPIOF_ODR.B13;
sbit TFT_CS at GPIOF_ODR.B12;
sbit TFT_RD at GPIOF_ODR.B14;
sbit TFT_WR at GPIOF_ODR.B15;
// End TFT module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1500;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TBox *local_box;
TBox *exec_box;
int box_order;

static void InitializeTouchPanel() {
  TFT_Init_SSD1963_7Inch_800x480(800, 480);   //ova funkcija mora da se pozove za displej 5"

  TFT_Set_DBC_SSD1963(255);

  TFT_Rotate_180(1);
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                ScreenNotepad;
  TBox                   BoxPaper;
  TImage               Image2;
  TLabel                 LabelRow0;
char LabelRow0_Caption[36] = "";

  TLabel                 LabelRow1;
char LabelRow1_Caption[36] = "";

  TLabel                 LabelRow2;
char LabelRow2_Caption[36] = "";

  TLabel                 LabelRow3;
char LabelRow3_Caption[36] = "";

  TLabel                 LabelRow4;
char LabelRow4_Caption[36] = "";

  TLabel                 LabelRow5;
char LabelRow5_Caption[36] = "";

  TLabel                 LabelRow6;
char LabelRow6_Caption[36] = "";

  TLabel                 LabelRow7;
char LabelRow7_Caption[36] = "";

  TLabel                 LabelRow8;
char LabelRow8_Caption[36] = "";

  TImage               ImageDialogBox;
  TLabel                 LabelDialogBox;
char LabelDialogBox_Caption[14] = "OvoJeIme.txt";

  TButton               ButtonMmcState;
char ButtonMmcState_Caption[31] = "Wait for Plugin";

  TButton                * const code Screen1_Buttons[1]=
         {
         &ButtonMmcState       
         };
  TLabel                 * const code Screen1_Labels[10]=
         {
         &LabelRow0,           
         &LabelRow1,           
         &LabelRow2,           
         &LabelRow3,           
         &LabelRow4,           
         &LabelRow5,           
         &LabelRow6,           
         &LabelRow7,           
         &LabelRow8,           
         &LabelDialogBox       
         };
  TImage                 * const code Screen1_Images[2]=
         {
         &Image2,              
         &ImageDialogBox       
         };
  TBox                   * const code Screen1_Boxes[1]=
         {
         &BoxPaper             
         };


  TScreen                ScreenWait;
  TImage               Image3;
  TCircle                CircleWait0;
  TCircle                CircleWait4;
  TCircle                CircleWait2;
  TCircle                CircleWait6;
  TCircle                CircleWait1;
  TCircle                CircleWait3;
  TCircle                CircleWait5;
  TCircle                CircleWait7;
  TLabel                 Label1;
char Label1_Caption[16] = "Wait for Plugin";

  TImage               ImageLogo;
  TLabel                 * const code Screen2_Labels[1]=
         {
         &Label1               
         };
  TImage                 * const code Screen2_Images[2]=
         {
         &Image3,              
         &ImageLogo            
         };
  TCircle                * const code Screen2_Circles[8]=
         {
         &CircleWait0,         
         &CircleWait4,         
         &CircleWait2,         
         &CircleWait6,         
         &CircleWait1,         
         &CircleWait3,         
         &CircleWait5,         
         &CircleWait7          
         };


  TScreen                ScreenWelcome;
  TLabel                 Label2;
char Label2_Caption[18] = "USB Host Keyboard";

  TLine                  LineBlackUp;
  TLine                  LineBlackDown;
  TLabel                 Label3;
char Label3_Caption[17] = "MikroElektronika";

  TLabel                 * const code Screen3_Labels[2]=
         {
         &Label2,              
         &Label3               
         };
  TLine                  * const code Screen3_Lines[2]=
         {
         &LineBlackUp,         
         &LineBlackDown        
         };




static void InitializeObjects() {
  ScreenNotepad.Color                     = 0xC618;
  ScreenNotepad.Width                     = 320;
  ScreenNotepad.Height                    = 480;
  ScreenNotepad.ButtonsCount              = 1;
  ScreenNotepad.Buttons                   = Screen1_Buttons;
  ScreenNotepad.LabelsCount               = 10;
  ScreenNotepad.Labels                    = Screen1_Labels;
  ScreenNotepad.ImagesCount               = 2;
  ScreenNotepad.Images                    = Screen1_Images;
  ScreenNotepad.CirclesCount              = 0;
  ScreenNotepad.BoxesCount                = 1;
  ScreenNotepad.Boxes                     = Screen1_Boxes;
  ScreenNotepad.LinesCount                = 0;
  ScreenNotepad.ObjectsCount              = 14;

  ScreenWait.Color                     = 0xF77E;
  ScreenWait.Width                     = 320;
  ScreenWait.Height                    = 480;
  ScreenWait.ButtonsCount              = 0;
  ScreenWait.LabelsCount               = 1;
  ScreenWait.Labels                    = Screen2_Labels;
  ScreenWait.ImagesCount               = 2;
  ScreenWait.Images                    = Screen2_Images;
  ScreenWait.CirclesCount              = 8;
  ScreenWait.Circles                   = Screen2_Circles;
  ScreenWait.BoxesCount                = 0;
  ScreenWait.LinesCount                = 0;
  ScreenWait.ObjectsCount              = 11;

  ScreenWelcome.Color                     = 0xF77E;
  ScreenWelcome.Width                     = 320;
  ScreenWelcome.Height                    = 480;
  ScreenWelcome.ButtonsCount              = 0;
  ScreenWelcome.LabelsCount               = 2;
  ScreenWelcome.Labels                    = Screen3_Labels;
  ScreenWelcome.ImagesCount               = 0;
  ScreenWelcome.CirclesCount              = 0;
  ScreenWelcome.BoxesCount                = 0;
  ScreenWelcome.LinesCount                = 2;
  ScreenWelcome.Lines                     = Screen3_Lines;
  ScreenWelcome.ObjectsCount              = 4;


  BoxPaper.OwnerScreen     = &ScreenNotepad;
  BoxPaper.Order           = 0;
  BoxPaper.Left            = 23;
  BoxPaper.Top             = 37;
  BoxPaper.Width           = 300;
  BoxPaper.Height          = 420;
  BoxPaper.Pen_Width       = 1;
  BoxPaper.Pen_Color       = 0xF77E;
  BoxPaper.Visible         = 0;
  BoxPaper.Active          = 0;
  BoxPaper.Transparent     = 1;
  BoxPaper.Gradient        = 0;
  BoxPaper.Gradient_Orientation    = 0;
  BoxPaper.Gradient_Start_Color    = 0xFFFF;
  BoxPaper.Gradient_End_Color      = 0xC618;
  BoxPaper.Color           = 0xF77E;
  BoxPaper.PressColEnabled     = 0;
  BoxPaper.Press_Color     = 0x8410;
  BoxPaper.OnUpPtr         = 0;
  BoxPaper.OnDownPtr       = 0;
  BoxPaper.OnClickPtr      = 0;
  BoxPaper.OnPressPtr      = 0;

  Image2.OwnerScreen     = &ScreenNotepad;
  Image2.Order           = 1;
  Image2.Left            = 0;
  Image2.Top             = 0;
  Image2.Width           = 300;
  Image2.Height          = 440;
  Image2.Picture_Type    = 0;
  Image2.Picture_Ratio   = 1;
  Image2.Picture_Name    = slika_bmp;
  Image2.Visible         = 1;
  Image2.Active          = 0;
  Image2.OnUpPtr         = 0;
  Image2.OnDownPtr       = 0;
  Image2.OnClickPtr      = 0;
  Image2.OnPressPtr      = 0;

  LabelRow0.OwnerScreen     = &ScreenNotepad;
  LabelRow0.Order           = 2;
  LabelRow0.Left            = 26;
  LabelRow0.Top             = 44;
  LabelRow0.Width           = 0;
  LabelRow0.Height          = 0;
  LabelRow0.Visible         = 1;
  LabelRow0.Active          = 0;
  LabelRow0.Caption         = LabelRow0_Caption;
  LabelRow0.FontName        = Tahoma14x16_BoldItalic;
  LabelRow0.Font_Color      = 0x0000;
  LabelRow0.OnUpPtr         = 0;
  LabelRow0.OnDownPtr       = 0;
  LabelRow0.OnClickPtr      = 0;
  LabelRow0.OnPressPtr      = 0;

  LabelRow1.OwnerScreen     = &ScreenNotepad;
  LabelRow1.Order           = 3;
  LabelRow1.Left            = 26;
  LabelRow1.Top             = 69;
  LabelRow1.Width           = 0;
  LabelRow1.Height          = 0;
  LabelRow1.Visible         = 1;
  LabelRow1.Active          = 0;
  LabelRow1.Caption         = LabelRow1_Caption;
  LabelRow1.FontName        = Tahoma14x16_BoldItalic;
  LabelRow1.Font_Color      = 0x0000;
  LabelRow1.OnUpPtr         = 0;
  LabelRow1.OnDownPtr       = 0;
  LabelRow1.OnClickPtr      = 0;
  LabelRow1.OnPressPtr      = 0;

  LabelRow2.OwnerScreen     = &ScreenNotepad;
  LabelRow2.Order           = 4;
  LabelRow2.Left            = 26;
  LabelRow2.Top             = 95;
  LabelRow2.Width           = 0;
  LabelRow2.Height          = 0;
  LabelRow2.Visible         = 1;
  LabelRow2.Active          = 0;
  LabelRow2.Caption         = LabelRow2_Caption;
  LabelRow2.FontName        = Tahoma14x16_BoldItalic;
  LabelRow2.Font_Color      = 0x0000;
  LabelRow2.OnUpPtr         = 0;
  LabelRow2.OnDownPtr       = 0;
  LabelRow2.OnClickPtr      = 0;
  LabelRow2.OnPressPtr      = 0;

  LabelRow3.OwnerScreen     = &ScreenNotepad;
  LabelRow3.Order           = 5;
  LabelRow3.Left            = 26;
  LabelRow3.Top             = 121;
  LabelRow3.Width           = 0;
  LabelRow3.Height          = 0;
  LabelRow3.Visible         = 1;
  LabelRow3.Active          = 0;
  LabelRow3.Caption         = LabelRow3_Caption;
  LabelRow3.FontName        = Tahoma14x16_BoldItalic;
  LabelRow3.Font_Color      = 0x0000;
  LabelRow3.OnUpPtr         = 0;
  LabelRow3.OnDownPtr       = 0;
  LabelRow3.OnClickPtr      = 0;
  LabelRow3.OnPressPtr      = 0;

  LabelRow4.OwnerScreen     = &ScreenNotepad;
  LabelRow4.Order           = 6;
  LabelRow4.Left            = 26;
  LabelRow4.Top             = 146;
  LabelRow4.Width           = 0;
  LabelRow4.Height          = 0;
  LabelRow4.Visible         = 1;
  LabelRow4.Active          = 0;
  LabelRow4.Caption         = LabelRow4_Caption;
  LabelRow4.FontName        = Tahoma14x16_BoldItalic;
  LabelRow4.Font_Color      = 0x0000;
  LabelRow4.OnUpPtr         = 0;
  LabelRow4.OnDownPtr       = 0;
  LabelRow4.OnClickPtr      = 0;
  LabelRow4.OnPressPtr      = 0;

  LabelRow5.OwnerScreen     = &ScreenNotepad;
  LabelRow5.Order           = 7;
  LabelRow5.Left            = 26;
  LabelRow5.Top             = 172;
  LabelRow5.Width           = 0;
  LabelRow5.Height          = 0;
  LabelRow5.Visible         = 1;
  LabelRow5.Active          = 0;
  LabelRow5.Caption         = LabelRow5_Caption;
  LabelRow5.FontName        = Tahoma14x16_BoldItalic;
  LabelRow5.Font_Color      = 0x0000;
  LabelRow5.OnUpPtr         = 0;
  LabelRow5.OnDownPtr       = 0;
  LabelRow5.OnClickPtr      = 0;
  LabelRow5.OnPressPtr      = 0;

  LabelRow6.OwnerScreen     = &ScreenNotepad;
  LabelRow6.Order           = 8;
  LabelRow6.Left            = 26;
  LabelRow6.Top             = 198;
  LabelRow6.Width           = 0;
  LabelRow6.Height          = 0;
  LabelRow6.Visible         = 1;
  LabelRow6.Active          = 0;
  LabelRow6.Caption         = LabelRow6_Caption;
  LabelRow6.FontName        = Tahoma14x16_BoldItalic;
  LabelRow6.Font_Color      = 0x0000;
  LabelRow6.OnUpPtr         = 0;
  LabelRow6.OnDownPtr       = 0;
  LabelRow6.OnClickPtr      = 0;
  LabelRow6.OnPressPtr      = 0;

  LabelRow7.OwnerScreen     = &ScreenNotepad;
  LabelRow7.Order           = 9;
  LabelRow7.Left            = 26;
  LabelRow7.Top             = 224;
  LabelRow7.Width           = 0;
  LabelRow7.Height          = 0;
  LabelRow7.Visible         = 1;
  LabelRow7.Active          = 0;
  LabelRow7.Caption         = LabelRow7_Caption;
  LabelRow7.FontName        = Tahoma14x16_BoldItalic;
  LabelRow7.Font_Color      = 0x0000;
  LabelRow7.OnUpPtr         = 0;
  LabelRow7.OnDownPtr       = 0;
  LabelRow7.OnClickPtr      = 0;
  LabelRow7.OnPressPtr      = 0;

  LabelRow8.OwnerScreen     = &ScreenNotepad;
  LabelRow8.Order           = 10;
  LabelRow8.Left            = 26;
  LabelRow8.Top             = 250;
  LabelRow8.Width           = 0;
  LabelRow8.Height          = 0;
  LabelRow8.Visible         = 1;
  LabelRow8.Active          = 0;
  LabelRow8.Caption         = LabelRow8_Caption;
  LabelRow8.FontName        = Tahoma14x16_BoldItalic;
  LabelRow8.Font_Color      = 0x0000;
  LabelRow8.OnUpPtr         = 0;
  LabelRow8.OnDownPtr       = 0;
  LabelRow8.OnClickPtr      = 0;
  LabelRow8.OnPressPtr      = 0;

  ImageDialogBox.OwnerScreen     = &ScreenNotepad;
  ImageDialogBox.Order           = 11;
  ImageDialogBox.Left            = 31;
  ImageDialogBox.Top             = 62;
  ImageDialogBox.Width           = 175;
  ImageDialogBox.Height          = 79;
  ImageDialogBox.Picture_Type    = 0;
  ImageDialogBox.Picture_Ratio   = 1;
  ImageDialogBox.Picture_Name    = saveDialogBox_bmp;
  ImageDialogBox.Visible         = 0;
  ImageDialogBox.Active          = 0;
  ImageDialogBox.OnUpPtr         = 0;
  ImageDialogBox.OnDownPtr       = 0;
  ImageDialogBox.OnClickPtr      = 0;
  ImageDialogBox.OnPressPtr      = 0;

  LabelDialogBox.OwnerScreen     = &ScreenNotepad;
  LabelDialogBox.Order           = 12;
  LabelDialogBox.Left            = 78;
  LabelDialogBox.Top             = 110;
  LabelDialogBox.Width           = 79;
  LabelDialogBox.Height          = 17;
  LabelDialogBox.Visible         = 0;
  LabelDialogBox.Active          = 0;
  LabelDialogBox.Caption         = LabelDialogBox_Caption;
  LabelDialogBox.FontName        = Tahoma13x16_Regular;
  LabelDialogBox.Font_Color      = 0x0000;
  LabelDialogBox.OnUpPtr         = 0;
  LabelDialogBox.OnDownPtr       = 0;
  LabelDialogBox.OnClickPtr      = 0;
  LabelDialogBox.OnPressPtr      = 0;

  ButtonMmcState.OwnerScreen     = &ScreenNotepad;
  ButtonMmcState.Order           = 13;
  ButtonMmcState.Left            = 24;
  ButtonMmcState.Top             = 196;
  ButtonMmcState.Width           = 188;
  ButtonMmcState.Height          = 31;
  ButtonMmcState.Pen_Width       = 1;
  ButtonMmcState.Pen_Color       = 0xF77E;
  ButtonMmcState.Visible         = 0;
  ButtonMmcState.Active          = 0;
  ButtonMmcState.Transparent     = 1;
  ButtonMmcState.Caption         = ButtonMmcState_Caption;
  ButtonMmcState.TextAlign       = _taCenter;
  ButtonMmcState.FontName        = Segoe_UI_Light17x19_Bold;
  ButtonMmcState.PressColEnabled = 0;
  ButtonMmcState.Font_Color      = 0x632C;
  ButtonMmcState.Gradient        = 0;
  ButtonMmcState.Gradient_Orientation    = 0;
  ButtonMmcState.Gradient_Start_Color    = 0xFFFF;
  ButtonMmcState.Gradient_End_Color      = 0xC618;
  ButtonMmcState.Color           = 0xF77E;
  ButtonMmcState.Press_Color     = 0xC618;
  ButtonMmcState.OnUpPtr         = 0;
  ButtonMmcState.OnDownPtr       = 0;
  ButtonMmcState.OnClickPtr      = 0;
  ButtonMmcState.OnPressPtr      = 0;

  Image3.OwnerScreen     = &ScreenWait;
  Image3.Order           = 0;
  Image3.Left            = 70;
  Image3.Top             = 47;
  Image3.Width           = 97;
  Image3.Height          = 128;
  Image3.Picture_Type    = 1;
  Image3.Picture_Ratio   = 1;
  Image3.Picture_Name    = welcomeJPG_jpg;
  Image3.Visible         = 1;
  Image3.Active          = 1;
  Image3.OnUpPtr         = 0;
  Image3.OnDownPtr       = 0;
  Image3.OnClickPtr      = 0;
  Image3.OnPressPtr      = 0;

  CircleWait0.OwnerScreen     = &ScreenWait;
  CircleWait0.Order           = 1;
  CircleWait0.Left            = 116;
  CircleWait0.Top             = 226;
  CircleWait0.Radius          = 5;
  CircleWait0.Pen_Width       = 1;
  CircleWait0.Pen_Color       = 0xF77E;
  CircleWait0.Visible         = 1;
  CircleWait0.Active          = 0;
  CircleWait0.Transparent     = 1;
  CircleWait0.Gradient        = 0;
  CircleWait0.Gradient_Orientation    = 0;
  CircleWait0.Gradient_Start_Color    = 0xFFFF;
  CircleWait0.Gradient_End_Color      = 0xC618;
  CircleWait0.Color           = 0xDEFB;
  CircleWait0.PressColEnabled = 1;
  CircleWait0.Press_Color     = 0x8410;
  CircleWait0.OnUpPtr         = 0;
  CircleWait0.OnDownPtr       = 0;
  CircleWait0.OnClickPtr      = 0;
  CircleWait0.OnPressPtr      = 0;

  CircleWait4.OwnerScreen     = &ScreenWait;
  CircleWait4.Order           = 2;
  CircleWait4.Left            = 116;
  CircleWait4.Top             = 257;
  CircleWait4.Radius          = 5;
  CircleWait4.Pen_Width       = 1;
  CircleWait4.Pen_Color       = 0xF77E;
  CircleWait4.Visible         = 1;
  CircleWait4.Active          = 0;
  CircleWait4.Transparent     = 1;
  CircleWait4.Gradient        = 0;
  CircleWait4.Gradient_Orientation    = 0;
  CircleWait4.Gradient_Start_Color    = 0xFFFF;
  CircleWait4.Gradient_End_Color      = 0xC618;
  CircleWait4.Color           = 0xF77E;
  CircleWait4.PressColEnabled = 1;
  CircleWait4.Press_Color     = 0x8410;
  CircleWait4.OnUpPtr         = 0;
  CircleWait4.OnDownPtr       = 0;
  CircleWait4.OnClickPtr      = 0;
  CircleWait4.OnPressPtr      = 0;

  CircleWait2.OwnerScreen     = &ScreenWait;
  CircleWait2.Order           = 3;
  CircleWait2.Left            = 132;
  CircleWait2.Top             = 242;
  CircleWait2.Radius          = 5;
  CircleWait2.Pen_Width       = 1;
  CircleWait2.Pen_Color       = 0xF77E;
  CircleWait2.Visible         = 1;
  CircleWait2.Active          = 0;
  CircleWait2.Transparent     = 1;
  CircleWait2.Gradient        = 0;
  CircleWait2.Gradient_Orientation    = 0;
  CircleWait2.Gradient_Start_Color    = 0xFFFF;
  CircleWait2.Gradient_End_Color      = 0xC618;
  CircleWait2.Color           = 0x8C51;
  CircleWait2.PressColEnabled = 1;
  CircleWait2.Press_Color     = 0x8410;
  CircleWait2.OnUpPtr         = 0;
  CircleWait2.OnDownPtr       = 0;
  CircleWait2.OnClickPtr      = 0;
  CircleWait2.OnPressPtr      = 0;

  CircleWait6.OwnerScreen     = &ScreenWait;
  CircleWait6.Order           = 4;
  CircleWait6.Left            = 101;
  CircleWait6.Top             = 242;
  CircleWait6.Radius          = 5;
  CircleWait6.Pen_Width       = 1;
  CircleWait6.Pen_Color       = 0xF77E;
  CircleWait6.Visible         = 1;
  CircleWait6.Active          = 0;
  CircleWait6.Transparent     = 1;
  CircleWait6.Gradient        = 0;
  CircleWait6.Gradient_Orientation    = 0;
  CircleWait6.Gradient_Start_Color    = 0xFFFF;
  CircleWait6.Gradient_End_Color      = 0xC618;
  CircleWait6.Color           = 0xF77E;
  CircleWait6.PressColEnabled = 1;
  CircleWait6.Press_Color     = 0x8410;
  CircleWait6.OnUpPtr         = 0;
  CircleWait6.OnDownPtr       = 0;
  CircleWait6.OnClickPtr      = 0;
  CircleWait6.OnPressPtr      = 0;

  CircleWait1.OwnerScreen     = &ScreenWait;
  CircleWait1.Order           = 5;
  CircleWait1.Left            = 127;
  CircleWait1.Top             = 231;
  CircleWait1.Radius          = 5;
  CircleWait1.Pen_Width       = 1;
  CircleWait1.Pen_Color       = 0xF77E;
  CircleWait1.Visible         = 1;
  CircleWait1.Active          = 0;
  CircleWait1.Transparent     = 1;
  CircleWait1.Gradient        = 0;
  CircleWait1.Gradient_Orientation    = 0;
  CircleWait1.Gradient_Start_Color    = 0xFFFF;
  CircleWait1.Gradient_End_Color      = 0xC618;
  CircleWait1.Color           = 0xCE79;
  CircleWait1.PressColEnabled = 1;
  CircleWait1.Press_Color     = 0x8410;
  CircleWait1.OnUpPtr         = 0;
  CircleWait1.OnDownPtr       = 0;
  CircleWait1.OnClickPtr      = 0;
  CircleWait1.OnPressPtr      = 0;

  CircleWait3.OwnerScreen     = &ScreenWait;
  CircleWait3.Order           = 6;
  CircleWait3.Left            = 128;
  CircleWait3.Top             = 253;
  CircleWait3.Radius          = 5;
  CircleWait3.Pen_Width       = 1;
  CircleWait3.Pen_Color       = 0xF77E;
  CircleWait3.Visible         = 1;
  CircleWait3.Active          = 0;
  CircleWait3.Transparent     = 1;
  CircleWait3.Gradient        = 0;
  CircleWait3.Gradient_Orientation    = 0;
  CircleWait3.Gradient_Start_Color    = 0xFFFF;
  CircleWait3.Gradient_End_Color      = 0xC618;
  CircleWait3.Color           = 0x528A;
  CircleWait3.PressColEnabled = 1;
  CircleWait3.Press_Color     = 0x8410;
  CircleWait3.OnUpPtr         = 0;
  CircleWait3.OnDownPtr       = 0;
  CircleWait3.OnClickPtr      = 0;
  CircleWait3.OnPressPtr      = 0;

  CircleWait5.OwnerScreen     = &ScreenWait;
  CircleWait5.Order           = 7;
  CircleWait5.Left            = 105;
  CircleWait5.Top             = 253;
  CircleWait5.Radius          = 5;
  CircleWait5.Pen_Width       = 1;
  CircleWait5.Pen_Color       = 0xF77E;
  CircleWait5.Visible         = 1;
  CircleWait5.Active          = 0;
  CircleWait5.Transparent     = 1;
  CircleWait5.Gradient        = 0;
  CircleWait5.Gradient_Orientation    = 0;
  CircleWait5.Gradient_Start_Color    = 0xFFFF;
  CircleWait5.Gradient_End_Color      = 0xC618;
  CircleWait5.Color           = 0xF77E;
  CircleWait5.PressColEnabled = 1;
  CircleWait5.Press_Color     = 0x8410;
  CircleWait5.OnUpPtr         = 0;
  CircleWait5.OnDownPtr       = 0;
  CircleWait5.OnClickPtr      = 0;
  CircleWait5.OnPressPtr      = 0;

  CircleWait7.OwnerScreen     = &ScreenWait;
  CircleWait7.Order           = 8;
  CircleWait7.Left            = 105;
  CircleWait7.Top             = 231;
  CircleWait7.Radius          = 5;
  CircleWait7.Pen_Width       = 1;
  CircleWait7.Pen_Color       = 0xF77E;
  CircleWait7.Visible         = 1;
  CircleWait7.Active          = 0;
  CircleWait7.Transparent     = 1;
  CircleWait7.Gradient        = 0;
  CircleWait7.Gradient_Orientation    = 0;
  CircleWait7.Gradient_Start_Color    = 0xFFFF;
  CircleWait7.Gradient_End_Color      = 0xC618;
  CircleWait7.Color           = 0xF77E;
  CircleWait7.PressColEnabled = 1;
  CircleWait7.Press_Color     = 0x8410;
  CircleWait7.OnUpPtr         = 0;
  CircleWait7.OnDownPtr       = 0;
  CircleWait7.OnClickPtr      = 0;
  CircleWait7.OnPressPtr      = 0;

  Label1.OwnerScreen     = &ScreenWait;
  Label1.Order           = 9;
  Label1.Left            = 59;
  Label1.Top             = 201;
  Label1.Width           = 119;
  Label1.Height          = 21;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Segoe_UI_Light17x19_Bold;
  Label1.Font_Color      = 0x632C;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = 0;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  ImageLogo.OwnerScreen     = &ScreenWait;
  ImageLogo.Order           = 10;
  ImageLogo.Left            = 81;
  ImageLogo.Top             = 145;
  ImageLogo.Width           = 14;
  ImageLogo.Height          = 14;
  ImageLogo.Picture_Type    = 0;
  ImageLogo.Picture_Ratio   = 1;
  ImageLogo.Picture_Name    = logo_bmp;
  ImageLogo.Visible         = 1;
  ImageLogo.Active          = 1;
  ImageLogo.OnUpPtr         = 0;
  ImageLogo.OnDownPtr       = 0;
  ImageLogo.OnClickPtr      = 0;
  ImageLogo.OnPressPtr      = 0;

  Label2.OwnerScreen     = &ScreenWelcome;
  Label2.Order           = 0;
  Label2.Left            = 25;
  Label2.Top             = 146;
  Label2.Width           = 193;
  Label2.Height          = 26;
  Label2.Visible         = 1;
  Label2.Active          = 1;
  Label2.Caption         = Label2_Caption;
  Label2.FontName        = Segoe_UI_Light21x24_Regular;
  Label2.Font_Color      = 0x632C;
  Label2.OnUpPtr         = 0;
  Label2.OnDownPtr       = 0;
  Label2.OnClickPtr      = 0;
  Label2.OnPressPtr      = 0;

  LineBlackUp.OwnerScreen     = &ScreenWelcome;
  LineBlackUp.Order           = 1;
  LineBlackUp.First_Point_X   = 0;
  LineBlackUp.First_Point_Y   = 0;
  LineBlackUp.Second_Point_X  = 240;
  LineBlackUp.Second_Point_Y  = 0;
  LineBlackUp.Visible         = 1;
  LineBlackUp.Pen_Width       = 1;
  LineBlackUp.Color           = 0x0000;

  LineBlackDown.OwnerScreen     = &ScreenWelcome;
  LineBlackDown.Order           = 2;
  LineBlackDown.First_Point_X   = 0;
  LineBlackDown.First_Point_Y   = 320;
  LineBlackDown.Second_Point_X  = 240;
  LineBlackDown.Second_Point_Y  = 320;
  LineBlackDown.Visible         = 1;
  LineBlackDown.Pen_Width       = 1;
  LineBlackDown.Color           = 0x0000;

  Label3.OwnerScreen     = &ScreenWelcome;
  Label3.Order           = 3;
  Label3.Left            = 56;
  Label3.Top             = 113;
  Label3.Width           = 122;
  Label3.Height          = 20;
  Label3.Visible         = 1;
  Label3.Active          = 1;
  Label3.Caption         = Label3_Caption;
  Label3.FontName        = Segoe_UI_Light16x18_Regular;
  Label3.Font_Color      = 0xF80C;
  Label3.OnUpPtr         = 0;
  Label3.OnDownPtr       = 0;
  Label3.OnClickPtr      = 0;
  Label3.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetImage(index)               CurrentScreen->Images[index]
#define GetCircle(index)              CurrentScreen->Circles[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]
#define GetLine(index)                CurrentScreen->Lines[index]


void DrawButton(TButton *Abutton) {
  if (Abutton->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taCenter)
      TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taRight)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible == 1) {
    TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage(TImage *AImage) {
  if (AImage->Visible) {
    if (AImage->Picture_Type == 0)
      TFT_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
    if (AImage->Picture_Type == 1)
      TFT_Image_Jpeg(AImage->Left, AImage->Top, AImage->Picture_Name);
  }
}

void DrawCircle(TCircle *ACircle) {
  if (ACircle->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
    }
    TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
    TFT_Circle(ACircle->Left + ACircle->Radius,
               ACircle->Top + ACircle->Radius,
               ACircle->Radius);
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible == 1) {
    TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  unsigned short circle_idx;
  TCircle *local_circle;
  unsigned short box_idx;
  TBox *local_box;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  circle_idx = 0;
  box_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {

    TFT_Init_SSD1963_7Inch_800x480(CurrentScreen->Width, CurrentScreen->Height);
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;

  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (circle_idx < CurrentScreen->CirclesCount) {
      local_circle = GetCircle(circle_idx);
      if (order == local_circle->Order) {
        circle_idx++;
        order++;
        DrawCircle(local_circle);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

    if (line_idx  < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

    if (image_idx  < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
    }

  }
}

void Init_MCU() {

  TFT_Set_Default_Mode();
  TP_TFT_Set_Default_Mode();
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  InitializeObjects();
  display_width = ScreenWelcome.Width;
  display_height = ScreenWelcome.Height;
  DrawScreen(&ScreenWelcome);
}