/*
 * Generated by:
     Visual TFT
 * Description
     Example showing usage of USB HID (keyboard) class. Attach usb cable into USB HOST (board specific)
     in order to connect keyboard to development board. After connection, the board recognize USB keyboard
     device and you can write text on "TFT Notepad Work Space". Also you can save written text on MMC card,
     by pressing "Ctrl+s", choosing file name and pressing "Enter". File name should be in DOS 8.3 (file_name.extension) format.
     Make sure that MMC card is properly formatted (to FAT16 or just FAT).
 * Test configuration:
     MCU:             STM32F107VC
     Dev.Board:       EasyMx_PRO_v7_for_STM32_ARM
                      http://www.mikroe.com/eng/products/view/852/easymx-pro-v7-for-stm32/
     Oscillator:      72000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 * NOTES:
     - Turn ON PSW and VBUS switches at SW12.7 and SW12.8 (board specific).
     - Turn ON MMC and SPI and CS switches at SW13.1, SW13.2, SW13.3 and SW14.3 (board specific).
     - Turn ON BUZZER switch at SW14.8.
     - Turn on TFT backlight switch SW11.3 (board specific).
 * Potrebno je ukljuciti tastaturu pre pokretanja primera
 */

#include "HIDDevice_Keyboard_objects.h"
#include "stdint.h"

// Externs
extern const _TRUE;

extern uint8_t CheckPlugOutIn();
extern void    WelcomeScreen();
extern void    ClearLineLabels();
extern void    SaveFile();
/////////////////////////////////

void main() {

  // Draw Welcome screen
  WelcomeScreen();

  while (1) {
  
    USBHost_Main();
    
    // Check is device plug-out and if it is, go to ScreenWait,
    // wait for plug-in, and return to ScreenNotepad
    if(CheckPlugOutIn() == _TRUE) {
      ClearLineLabels();
      DrawScreen(&ScreenNotepad);
    }
    
    // Handle Save Mode
    //SaveFile();
    
  }
}