typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Image {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef struct  Circle {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Radius;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCircle;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           ImagesCount;
  TImage                 * const code *Images;
  unsigned int           CirclesCount;
  TCircle                * const code *Circles;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           LinesCount;
  TLine                 * const code *Lines;
};

extern   TScreen                ScreenNotepad;
extern   TBox                   BoxPaper;
extern   TImage               Image2;
extern   TLabel                 LabelRow0;
extern   TLabel                 LabelRow1;
extern   TLabel                 LabelRow2;
extern   TLabel                 LabelRow3;
extern   TLabel                 LabelRow4;
extern   TLabel                 LabelRow5;
extern   TLabel                 LabelRow6;
extern   TLabel                 LabelRow7;
extern   TLabel                 LabelRow8;
extern   TImage               ImageDialogBox;
extern   TLabel                 LabelDialogBox;
extern   TButton               ButtonMmcState;
extern   TButton                * const code Screen1_Buttons[1];
extern   TLabel                 * const code Screen1_Labels[10];
extern   TImage                 * const code Screen1_Images[2];
extern   TBox                   * const code Screen1_Boxes[1];


extern   TScreen                ScreenWait;
extern   TImage               Image3;
extern   TCircle                CircleWait0;
extern   TCircle                CircleWait4;
extern   TCircle                CircleWait2;
extern   TCircle                CircleWait6;
extern   TCircle                CircleWait1;
extern   TCircle                CircleWait3;
extern   TCircle                CircleWait5;
extern   TCircle                CircleWait7;
extern   TLabel                 Label1;
extern   TImage               ImageLogo;
extern   TLabel                 * const code Screen2_Labels[1];
extern   TImage                 * const code Screen2_Images[2];
extern   TCircle                * const code Screen2_Circles[8];


extern   TScreen                ScreenWelcome;
extern   TLabel                 Label2;
extern   TLine                  LineBlackUp;
extern   TLine                  LineBlackDown;
extern   TLabel                 Label3;
extern   TLabel                 * const code Screen3_Labels[2];
extern   TLine                  * const code Screen3_Lines[2];



/////////////////////////
// Events Code Declarations
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char BoxPaper_Caption[];
extern char Image2_Caption[];
extern char LabelRow0_Caption[];
extern char LabelRow1_Caption[];
extern char LabelRow2_Caption[];
extern char LabelRow3_Caption[];
extern char LabelRow4_Caption[];
extern char LabelRow5_Caption[];
extern char LabelRow6_Caption[];
extern char LabelRow7_Caption[];
extern char LabelRow8_Caption[];
extern char ImageDialogBox_Caption[];
extern char LabelDialogBox_Caption[];
extern char ButtonMmcState_Caption[];
extern char Image3_Caption[];
extern char CircleWait0_Caption[];
extern char CircleWait4_Caption[];
extern char CircleWait2_Caption[];
extern char CircleWait6_Caption[];
extern char CircleWait1_Caption[];
extern char CircleWait3_Caption[];
extern char CircleWait5_Caption[];
extern char CircleWait7_Caption[];
extern char Label1_Caption[];
extern char ImageLogo_Caption[];
extern char Label2_Caption[];
extern char LineBlackUp_Caption[];
extern char LineBlackDown_Caption[];
extern char Label3_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void DrawCircle(TCircle *ACircle);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
